package net.sergeych.bipack

import kotlinx.serialization.Serializable
import net.sergeych.bintools.toDump
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.Test

@Serializable
@ExtendableFormat
data class Foobar1(val bar: Int, val foo: Int = 117)

@Serializable
@ExtendableFormat
data class Foobar2(val bar: Int, val foo: Int,val other: Int = -1)

class BipackEncoderTest {

    @Test
    fun encodeSimple() {
        val a = Foobar1(42)//, "bum")
        println(BipackEncoder.encode(a).toDump())
        val b = BipackDecoder.decode<Foobar1>(BipackEncoder.encode(a))
        assertEquals(a, b)
        val c = BipackDecoder.decode<Foobar2>(BipackEncoder.encode(a))
        assertEquals(-1, c.other)
//        assertEquals(a.foo, c.foo)
        assertEquals(a.bar, c.bar)
//        assertEquals(a.buzz, c.buzz)
    }
}